# Copyright 2016 Osvaldo Santana Neto
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


from .user import Service, ExtraService

TRACKING_PREFIX = {
    "AL": "Agentes de leitura",
    "AR": "Avisos de recebimento",
    "AS": "PAC - Ação Social",
    "CA": "Encomenda Internacional - Colis",
    "CB": "Encomenda Internacional - Colis",
    "CC": "Encomenda Internacional - Colis",
    "CD": "Encomenda Internacional - Colis",
    "CE": "Encomenda Internacional - Colis",
    "CF": "Encomenda Internacional - Colis",
    "CG": "Encomenda Internacional - Colis",
    "CH": "Encomenda Internacional - Colis",
    "CI": "Encomenda Internacional - Colis",
    "CJ": "Encomenda Internacional - Colis",
    "CK": "Encomenda Internacional - Colis",
    "CL": "Encomenda Internacional - Colis",
    "CM": "Encomenda Internacional - Colis",
    "CN": "Encomenda Internacional - Colis",
    "CO": "Encomenda Internacional - Colis",
    "CP": "Encomenda Internacional - Colis",
    "CQ": "Encomenda Internacional - Colis",
    "CR": "Carta registrada sem Valor Declarado",
    "CS": "Encomenda Internacional - Colis",
    "CT": "Encomenda Internacional - Colis",
    "CU": "Encomenda internacional - Colis",
    "CV": "Encomenda Internacional - Colis",
    "CW": "Encomenda Internacional - Colis",
    "CX": "Encomenda internacional - Colis ou Selo Lacre para Caixetas",
    "CY": "Encomenda Internacional - Colis",
    "CZ": "Encomenda Internacional - Colis",
    "DA": "SEDEX ou Remessa Expressa com AR Digital",
    "DB": "SEDEX ou Remessa Expressa com AR Digital (Bradesco)",
    "DC": "Remessa Expressa CRLV/CRV/CNH e Notificações",
    "DD": "Devolução de documentos",
    "DE": "Remessa Expressa Talão/Cartão com AR",
    "DF": "e-SEDEX",
    "DG": "SEDEX",
    "DI": "SEDEX ou Remessa Expressa com AR Digital (Itaú)",
    "DJ": "SEDEX",
    "DK": "PAC Extra Grande",
    "DL": "SEDEX",
    "DM": "e-SEDEX",
    "DN": "SEDEX",
    "DO": "SEDEX ou Remessa Expressa com AR Digital (Itaú)",
    "DP": "SEDEX Pagamento na Entrega",
    "DQ": "SEDEX ou Remessa Expressa com AR Digital (Santander)",
    "DR": "Remessa Expressa com AR Digital (Santander)",
    "DS": "SEDEX ou Remessa Expressa com AR Digital (Santander)",
    "DT": "Remessa econômica com AR Digital (DETRAN)",
    "DU": "e-SEDEX",
    "DV": "SEDEX c/ AR digital",
    "DW": "Encomenda SEDEX (Etiqueta Lógica)",
    "DX": "SEDEX 10",
    "EA": "Encomenda Internacional - EMS",
    "EB": "Encomenda Internacional - EMS",
    "EC": "PAC",
    "ED": "Packet Express",
    "EE": "Encomenda Internacional - EMS",
    "EF": "Encomenda Internacional - EMS",
    "EG": "Encomenda Internacional - EMS",
    "EH": "Encomenda Internacional - EMS ou Encomenda com AR Digital",
    "EI": "Encomenda Internacional - EMS",
    "EJ": "Encomenda Internacional - EMS",
    "EK": "Encomenda Internacional - EMS",
    "EL": "Encomenda Internacional - EMS",
    "EM": "Encomenda Internacional - SEDEX Mundi",  # BR Suffix
    # "EM": "Encomenda Internacional - EMS Importação",
    "EN": "Encomenda Internacional - EMS",
    "EO": "Encomenda Internacional - EMS",
    "EP": "Encomenda Internacional - EMS",
    "EQ": "Encomenda de serviço não expressa (ECT)",
    "ER": "Objeto registrado",
    "ES": "e-SEDEX ou EMS",
    "ET": "Encomenda Internacional - EMS",
    "EU": "Encomenda Internacional - EMS",
    "EV": "Encomenda Internacional - EMS",
    "EW": "Encomenda Internacional - EMS",
    "EX": "Encomenda Internacional - EMS",
    "EY": "Encomenda Internacional - EMS",
    "EZ": "Encomenda Internacional - EMS",
    "FA": "FAC registrado",
    "FE": "Encomenda FNDE",
    "FF": "Objeto registrado (DETRAN)",
    "FH": "FAC registrado com AR Digital",
    "FM": "FAC monitorado",
    "FR": "FAC registrado",
    "IA": "Logística Integrada (agendado / avulso)",
    "IC": "Logística Integrada (a cobrar)",
    "ID": "Logística Integrada (devolução de documento)",
    "IE": "Logística Integrada (Especial)",
    "IF": "CPF",
    "II": "Logística Integrada (ECT)",
    "IK": "Logística Integrada com Coleta Simultânea",
    "IM": "Logística Integrada (Medicamentos)",
    "IN": "Correspondência e EMS recebido do Exterior",
    "IP": "Logística Integrada (Programada)",
    "IR": "Impresso Registrado",
    "IS": "Logística integrada standard (medicamentos)",
    "IT": "Remessa Expressa Medicamentos / Logística Integrada Termolábil",
    "IU": "Logística Integrada (urgente)",
    "IX": "EDEI Expresso",
    "JA": "Remessa econômica com AR Digital",
    "JB": "Remessa econômica com AR Digital",
    "JC": "Remessa econômica com AR Digital",
    "JD": "Remessa econômica Talão/Cartão",
    "JE": "Remessa econômica com AR Digital",
    "JF": "Remessa econômica com AR Digital",
    "JG": "Objeto registrado urgente/prioritário",
    "JH": "Objeto registrado urgente / prioritário",
    "JI": "Remessa econômica Talão/Cartão",
    "JJ": "Objeto registrado (Justiça)",
    "JK": "Remessa econômica Talão/Cartão",
    "JL": "Objeto registrado",
    "JM": "Mala Direta Postal Especial",
    "JN": "Objeto registrado econômico",
    "JO": "Objeto registrado urgente",
    "JP": "Receita Federal",
    "JQ": "Remessa econômica com AR Digital",
    "JR": "Objeto registrado urgente / prioritário",
    "JS": "Objeto registrado",
    "JT": "Objeto Registrado Urgente",
    "JV": "Remessa Econômica (c/ AR DIGITAL)",
    "LA": "SEDEX com Logística Reversa Simultânea em Agência",
    "LB": "e-SEDEX com Logística Reversa Simultânea em Agência",
    "LC": "Objeto Internacional (Prime)",
    "LE": "Logística Reversa Econômica",
    "LF": "Objeto Internacional (Prime)",
    "LI": "Objeto Internacional (Prime)",
    "LJ": "Objeto Internacional (Prime)",
    "LK": "Objeto Internacional (Prime)",
    "LM": "Objeto Internacional (Prime)",
    "LN": "Objeto Internacional (Prime)",
    "LP": "PAC com Logística Reversa Simultânea em Agência",
    "LS": "SEDEX Logística Reversa",
    "LV": "Logística Reversa Expressa",
    "LX": "Packet Standard / Econômica",
    "LZ": "Objeto Internacional (Prime)",
    "MA": "Serviços adicionais do Telegrama",
    "MB": "Telegrama (balcão)",
    "MC": "Telegrama (Fonado)",
    "MD": "SEDEX Mundi (Documento interno)",
    "ME": "Telegrama",
    "MF": "Telegrama (Fonado)",
    "MK": "Telegrama (corporativo)",
    "ML": "Fecha Malas (Rabicho)",
    "MM": "Telegrama (Grandes clientes)",
    "MP": "Telegrama (Pré-pago)",
    "MR": "AR digital",
    "MS": "Encomenda Saúde",
    "MT": "Telegrama (Telemail)",
    "MY": "Telegrama internacional (entrante)",
    "MZ": "Telegrama (Correios Online)",
    "NE": "Tele Sena resgatada",
    "NX": "EDEI Econômico (não urgente)",
    "PA": "Passaporte",
    "PB": "PAC",
    "PC": "PAC a Cobrar",
    "PD": "PAC",
    "PE": "PAC",
    "PF": "Passaporte",
    "PG": "PAC",
    "PH": "PAC",
    "PI": "PAC",
    "PJ": "PAC",
    "PK": "PAC Extra Grande",
    "PL": "PAC",
    "PR": "Reembolso Postal",
    "QQ": "Objeto de teste (SIGEP Web)",
    "RA": "Objeto registrado / prioritário",
    "RB": "Carta registrada",
    "RC": "Carta registrada com Valor Declarado",
    "RD": "Remessa econômica ou objeto registrado (DETRAN)",
    "RE": "Objeto registrado econômico",
    "RF": "Receita Federal",
    "RG": "Objeto registrado",
    "RH": "Objeto registrado com AR Digital",
    "RI": "Objeto registrado internacional prioritário",
    "RJ": "Objeto registrado",
    "RK": "Objeto registrado",
    "RL": "Objeto registrado",
    "RM": "Objeto registrado urgente",
    "RN": "Objeto registrado (SIGEPWEB ou Agência)",
    "RO": "Objeto registrado",
    "RP": "Reembolso Postal",
    "RQ": "Objeto registrado",
    "RR": "Objeto registrado",
    "RS": "Objeto registrado",
    "RT": "Remessa econômica Talão/Cartão",
    "RU": "Objeto registrado (ECT)",
    "RV": "Remessa econômica CRLV/CRV/CNH e Notificações com AR Digital",
    "RW": "Objeto internacional",
    "RX": "Objeto internacional",
    "RY": "Remessa econômica Talão/Cartão com AR Digital",
    "RZ": "Objeto registrado",
    "SA": "SEDEX",
    "SB": "SEDEX 10",
    "SC": "SEDEX a cobrar",
    "SD": "SEDEX ou Remessa Expressa (DETRAN)",
    "SE": "SEDEX",
    "SF": "SEDEX",
    "SG": "SEDEX",
    "SH": "SEDEX com AR Digital / SEDEX ou AR Digital",
    "SI": "SEDEX",
    "SJ": "SEDEX Hoje",
    "SK": "SEDEX",
    "SL": "SEDEX",
    "SM": "SEDEX 12",
    "SN": "SEDEX",
    "SO": "SEDEX",
    "SP": "SEDEX Pré-franqueado",
    "SQ": "SEDEX",
    "SR": "SEDEX",
    "SS": "SEDEX",
    "ST": "Remessa Expressa Talão/Cartão",
    "SU": "Encomenda de serviço expressa (ECT)",
    "SV": "Remessa Expressa CRLV/CRV/CNH e Notificações com AR Digital",
    "SW": "e-SEDEX",
    "SX": "SEDEX 10",
    "SY": "Remessa Expressa Talão/Cartão com AR Digital",
    "SZ": "SEDEX",
    "TC": "Objeto para treinamento",
    "TE": "Objeto para treinamento",
    "TS": "Objeto para treinamento",
    "VA": "Encomendas com valor declarado",
    "VC": "Encomendas",
    "VD": "Encomendas com valor declarado",
    "VE": "Encomendas",
    "VF": "Encomendas com valor declarado",
    "VV": "Objeto internacional",
    "XA": "Aviso de chegada (internacional)",
    "XM": "SEDEX Mundi",
    "XR": "Encomenda SUR Postal Expresso",
    "XX": "Encomenda SUR Postal 24 horas",
}

EXTRA_SERVICES_LIST = [
    ExtraService(1, "AR", "Aviso de Recebimento"),
    ExtraService(2, "MP", "Mão Própria Nacional"),
    ExtraService(19, "VD", "Valor Declarado (Encomendas)"),
    ExtraService(25, "RN", "Registro Nacional"),
    ExtraService(37, "??", "Aviso de Recebimento Digital"),
    ExtraService(49, "??", "Devolução de Nota Fiscal - SEDEX"),
    ExtraService(57, "??", "Taxa de Entrega de Encomenda Despadronizada"),
    ExtraService(67, "??", "Logística Reversa Simultânea Domiciliária"),
    ExtraService(69, "??", "Logística Reversa Simultânea em Agência"),
]

EXTRA_SERVICES = {s.number: s for s in EXTRA_SERVICES_LIST}
EXTRA_SERVICE_AR = EXTRA_SERVICES[1]
EXTRA_SERVICE_MP = EXTRA_SERVICES[2]
EXTRA_SERVICE_VD = EXTRA_SERVICES[19]
EXTRA_SERVICE_RN = EXTRA_SERVICES[25]

SERVICE_LIST = [
    Service(id=104707, code=40215, display_name='SEDEX 10',
            description='SEDEX 10', category='SERVICO_COM_RESTRICAO', postal_code=244, symbol="premium",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=104672, code=81019, display_name='E-SEDEX',
            description='E-SEDEX STANDARD', category='SERVICO_COM_RESTRICAO', postal_code=275, symbol="express",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=109819, code=41068, display_name='PAC',
            description='PAC', category='PAC', postal_code=201, symbol="standard",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=109811, code=40444, display_name='SEDEX',
            description='SEDEX - CONTRATO', category='SEDEX', postal_code=263, symbol="express",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=109810, code=40436, display_name='SEDEX',
            description='SEDEX - CONTRATO', category='SEDEX', postal_code=263, symbol="express",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=104625, code=40096, display_name='SEDEX',
            description='SEDEX (CONTRATO)', category='SEDEX', postal_code=263, symbol="express",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=109806, code=40380, display_name='SEDEX',
            description='SEDEX REVERSO 40096', category='REVERSO', postal_code=740, symbol="express",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=104295, code=40010, display_name='SEDEX',
            description='SEDEX A VISTA', category='SEDEX', postal_code=275, symbol="express",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=113546, code=41211, display_name='PAC',
            description='PAC - CONTRATO', category='PAC', postal_code=201, symbol="standard",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=114976, code=40630, display_name='SEDEX',
            description='SEDEX PAGAMENTO NA ENTREGA -', category='SEDEX', postal_code=641, symbol="express",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=118568, code=40916, display_name='SEDEX',
            description='SEDEX AGRUPADO II', category='SEDEX', postal_code=275, symbol="express",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=118567, code=40908, display_name='SEDEX',
            description='SEDEX AGRUPADO I', category='SEDEX', postal_code=275, symbol="express",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=120366, code=41300, display_name='PAC',
            description='PAC GRANDES FORMATOS', category='SERVICO_COM_RESTRICAO', postal_code=275, symbol="standard",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=115218, code=40169, display_name='SEDEX 12',
            description='SEDEX 12', category='SERVICO_COM_RESTRICAO', postal_code=263, symbol="premium",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=108934, code=40290, display_name='SEDEX Hoje',
            description='SEDEX HOJE', category='SERVICO_COM_RESTRICAO', postal_code=263, symbol="premium",
            default_extra_services=[EXTRA_SERVICE_RN]),
    Service(id=118424, code=10154, display_name='Carta Registrada',
            description='CARTA COMERCIAL  REGISTRADA', category='CARTA_REGISTRADA', postal_code=275),
    Service(id=115487, code=41246, display_name='Papai Noel dos Correios',
            description='REM. CAMPANHA PAPAI NOEL DOS', category='SEM_CATEGORIA', postal_code=276),
    Service(id=115136, code=40150, display_name='Protocolo',
            description='SERVICO DE PROTOCOLO POSTAL -', category='SEDEX', postal_code=263),
    Service(id=109480, code=10065, display_name='Carta Comercial',
            description='CARTA COMERCIAL A FATURAR', category='CARTA_REGISTRADA', postal_code=275)
]

SERVICES = {s.code: s for s in SERVICE_LIST}
SERVICE_PAC = SERVICES[41068]
SERVICE_SEDEX = SERVICES[40096]
SERVICE_SEDEX10 = SERVICES[40215]
SERVICE_SEDEX12 = SERVICES[40169]
SERVICE_E_SEDEX = SERVICES[81019]
